# Record Class LLRole

java.lang.Object
java.lang.Record
com.io7m.looseleaf.security.LLRole

Record Components:
  `name` - The role name
  `grants` - The access the role grants

public record LLRole(LLRoleName name, List<LLGrant> grants) extends Record
A role.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LLRole(LLRoleName name, List<LLGrant> grants)`
  A role.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `allows(LLAction action, LLKeyName keyName)`
  Determine if the given action is allowed on the given key according to this role.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `List<LLGrant>`
  `grants()`
  Returns the value of the `grants` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `LLRoleName`
  `name()`
  Returns the value of the `name` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### LLRole

    public LLRole(LLRoleName name, List<LLGrant> grants)
    A role.
    Parameters:
      `name` - The role name
      `grants` - The access the role grants

- ## Method Details

  - ### allows

    public boolean allows(LLAction action, LLKeyName keyName)
    Determine if the given action is allowed on the given key according to this role.
    Parameters:
      `action` - The action
      `keyName` - The key
    Returns:
      `true` if the action is allowed

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### name

    public LLRoleName name()
    Returns the value of the `name` record component.
    Returns:
      the value of the `name` record component

  - ### grants

    public List<LLGrant> grants()
    Returns the value of the `grants` record component.
    Returns:
      the value of the `grants` record component